Bug 226995 - net-im/uTox: fails to link with lld as the system linker
Summary: net-im/uTox: fails to link with lld as the system linker
Status: Closed FIXED
Alias: None
Product: Ports & Packages
Classification: Unclassified
Component: Individual Port(s) (show other bugs)
Version: Latest
Hardware: Any Any
: --- Affects Only Me
Assignee: freebsd-ports-bugs mailing list
URL:
Keywords:
Depends on:
Blocks: 214864
  Show dependency treegraph
 
Reported: 2018-03-27 16:31 UTC by Ed Maste
Modified: 2018-03-28 13:50 UTC (History)
1 user (show)

See Also:
bugzilla: maintainer-feedback? (portmaster)


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Ed Maste freebsd_committer 2018-03-27 16:31:34 UTC
I'm working on switching to LLVM's lld linker as the FreeBSD system linker (/usr/bin/ld)[1], and the port in this PR is reported as a new failure in the exp-run, PR 214864.

An excerpt from the build log[2]:
---
cd /wrkdirs/usr/ports/net-im/uTox/work/uTox-1835eae && cd /wrkdirs/usr/ports/net-im/uTox/work/uTox-1835eae/ && ld -r -b binary -o /wrkdirs/usr/ports/net-im/uTox/work/uTox-1835eae/icon.o icons/utox-128x128.png
ld: error: target emulation unknown: -m or at least one .o file required
---

Known issues in this port or in lld that affect this port:

(4) lld does not have a built-in default output target. For the most common use of the linker (linking individual .o objects into an executable or shared object) lld infers the target from the first object file. However, when the linker is used to convert an arbitrary binary file into an ELF object (via -r -b binary) lld must have the output target specified explicitly with -m.

FreeBSD 11 and later have lld available as /usr/bin/ld.lld, so one simple option for testing is to just symlink /usr/bin/ld to ld.lld (and restore it to ld.bfd).

A port Makefile knob, LLD_UNSAFE=yes, exists to indicate that a port does not work with lld, and requires either /usr/bin/ld.bfd or binutils from ports. This should work for the common case of ports written in C using GNU autoconf; it may have no effect on other ports.

[1] https://lists.freebsd.org/pipermail/freebsd-current/2018-March/068985.html
[2] http://package18.nyi.freebsd.org/data/headamd64PR214864-default/2018-03-21_17h43m11s/logs/errors/uTox-0.11.1_6.log
Comment 1 Ed Maste freebsd_committer 2018-03-27 20:49:21 UTC
Via tobik@ in ports r465725, BINARY_ALIAS=ld=ld.bfd may be an effective workaround if LLD_UNSAFE does not work.
Comment 2 commit-hook freebsd_committer 2018-03-28 13:45:10 UTC
A commit references this bug:

Author: krion
Date: Wed Mar 28 13:44:32 UTC 2018
New revision: 465809
URL: https://svnweb.freebsd.org/changeset/ports/465809

Log:
  Switch to ld.bfd by default as ld.ldd doesn't have built-in default
  output target. Pet portlint(1).

  PR:		226995
  Submitted by:	emaste
  Approved by:	portmgr (LLD_UNSAFE blanket)

Changes:
  head/net-im/uTox/Makefile